function t=dlt(ipts,bpts)
%
%  code for Direct Linear Transformation,
%  ideally bpts = H ipts
%
% Richard Hartley and Andrew Zisserman, Multiple View Geometry in Computer Vision, 
% Cambridge, 2000. Section 4.1 (pg 88)
%
N=length(ipts);
A=[];
x1=[ipts ones(N,1)];
x2=[bpts ones(N,1)];
for i=1:N
    v=x1(i,:);
    row1 = [0, 0, 0, -v, v*x2(i,2) ];
    row2 = [v, 0, 0, 0, -v*x2(i,1)];
    A = vertcat(A, row1, row2);
end;
[U,S,V] = svd(A);
H=(reshape(V(:,end),[3 3]));
t=projective2d(H);
