%% tform3

%%

clear
close all
load imgdata

im = im2double(imread(filename));
imshow(im);

% reduce figure size
pos = get(gcf,"Position");
pos(3:4) = [size(im,2) size(im,1)]*0.2;
set(gcf,"Position",pos);

%%

tf = fitgeotrans(imgPoints,worldPoints*10,'projective');
format short g
TA = tf.T
fprintf('norm(TA) = %g\n',norm(TA));

%%

w = transformPointsForward(tf,imgPoints(12,:))/10
display('should match');
w2 = worldPoints(12,:)

%%

[xf1, xf1_ref] = imwarp(im,tf,'fillValue',[0.5 0.5 1]);
imshow(imresize(xf1,0.2)); title('Projective transformed output using tform')
xf1_ref

%%

% choose a truncated region to display (worldpoints extend 0 to 210)
% xf1_ref.XWorldLimits = [-15 225];
% xf1_ref.YWorldLimits = [-15 225];
xf1_ref.XWorldLimits = [-90 300];
xf1_ref.YWorldLimits = [-90 300];
xf1_ref.ImageSize = [600 600];
[xf2 xf2_ref] = imwarp(im,tf,'OutputView',xf1_ref,'FillValues',[0.5 0.5 1]);
xf2_ref
imshow(xf2)


%%

% use the dlt algorithm
tf2 = dlt(imgPoints,worldPoints*10);
format short g
TB = tf2.T
fprintf('norm(TB) = %g\n',norm(TB));


%%

% ratio of elements (after adjusting T(3,3))
format short g
fact = TA(3,3)/TB(3,3)
TC = TB * fact

ratio = TC./TA
format short


